Index: java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 101)
@@ -3,4 +3,6 @@
 import com.framsticks.communication.queries.ApplicationRequest;
 import com.framsticks.communication.queries.CallRequest;
+import com.framsticks.communication.queries.NeedFile;
+import com.framsticks.communication.queries.NeedFileAcceptor;
 import com.framsticks.communication.queries.ProtocolRequest;
 import com.framsticks.communication.queries.RegisterRequest;
@@ -43,4 +45,19 @@
 	private boolean isHandshakeDone = false;
 
+	protected NeedFileAcceptor needFileAcceptor;
+
+	/**
+	 * @return the needFileAcceptor
+	 */
+	public NeedFileAcceptor getNeedFileAcceptor() {
+		return needFileAcceptor;
+	}
+
+	/**
+	 * @param needFileAcceptor the needFileAcceptor to set
+	 */
+	public void setNeedFileAcceptor(NeedFileAcceptor needFileAcceptor) {
+		this.needFileAcceptor = needFileAcceptor;
+	}
 
 	/**
@@ -64,6 +81,4 @@
 		protocolVersion = -1;
 	}
-
-
 
 	protected List<String> readFileContent() {
@@ -116,8 +131,4 @@
 	}
 
-	private Map<Integer, SentQuery<?>> queryMap = new HashMap<>();
-
-	private SentQuery<?> currentlySentQuery;
-
 	public void send(ProtocolRequest request, ClientSideResponseFuture callback) {
 		//TODO RunAt
@@ -154,25 +165,10 @@
 		sentQuery.dispatcher = dispatcher;
 
+
 		senderThread.dispatch(new RunAt<Connection>(callback) {
 			@Override
 			protected void runAt() {
-				Integer id;
-				synchronized (ClientSideManagedConnection.this) {
-
-					while (!(requestIdEnabled || currentlySentQuery == null)) {
-						try {
-							ClientSideManagedConnection.this.wait();
-						} catch (InterruptedException ignored) {
-							break;
-						}
-					}
-					if (requestIdEnabled) {
-						queryMap.put(nextQueryId, sentQuery);
-						id = nextQueryId++;
-					} else {
-						currentlySentQuery = sentQuery;
-						id = null;
-					}
-				}
+				Integer id = sentQueries.put(null, sentQuery);
+
 				String command = sentQuery.request.getCommand();
 				StringBuilder message = new StringBuilder();
@@ -188,14 +184,6 @@
 				flushOut();
 				log.debug("sending query: {}", out);
-
 			}
 		});
-		/*
-		synchronized (this) {
-			log.debug("queueing query: {}", query);
-			queryQueue.offer(sentQuery);
-			notifyAll();
-		}
-		 */
 	}
 
@@ -204,5 +192,4 @@
 		return "client connection " + address;
 	}
-
 
 	private void sendQueryVersion(final int version, final Future<Void> future) {
@@ -229,32 +216,70 @@
 	}
 
-	private synchronized @Nonnull SentQuery<?> fetchQuery(@Nullable Integer id, boolean remove) {
-		try {
-			if (id == null) {
-				if (requestIdEnabled) {
-					throw new FramsticksException().msg("request_id is enabled and id is missing");
-				}
-				SentQuery<?> result = currentlySentQuery;
-				if (remove) {
-					currentlySentQuery = null;
-					notifyAll();
-				}
-				return result;
-			}
-
-			if (!queryMap.containsKey(id)) {
-				throw new FramsticksException().msg("id is unknown").arg("id", id);
-			}
-
-			SentQuery<?> result = queryMap.get(id);
-			if (remove) {
-				queryMap.remove(id);
-			}
-			return result;
-
-		} catch (FramsticksException e) {
-			throw new FramsticksException().msg("failed to match response to sent query").cause(e);
-		}
-	}
+	protected class IdCollection<T> {
+
+
+		protected final Map<Integer, T> map = new HashMap<>();
+		protected T current;
+
+		public Integer put(Integer idProposition, T value) {
+			synchronized (ClientSideManagedConnection.this) {
+				while (!(requestIdEnabled || current == null)) {
+					try {
+						ClientSideManagedConnection.this.wait();
+					} catch (InterruptedException ignored) {
+						break;
+					}
+				}
+				if (!requestIdEnabled) {
+					current = value;
+					return null;
+				}
+				if (idProposition == null) {
+					idProposition = nextQueryId++;
+				}
+				map.put(idProposition, value);
+				return idProposition;
+			}
+		}
+
+		public void clear(Integer id) {
+			if (requestIdEnabled) {
+				current = null;
+			} else {
+				map.remove(id);
+			}
+		}
+
+		public @Nonnull T fetch(@Nullable Integer id, boolean remove) {
+			synchronized (ClientSideManagedConnection.this) {
+				try {
+					if (id == null) {
+						if (requestIdEnabled) {
+							throw new FramsticksException().msg("request_id is enabled and id is missing");
+						}
+						T result = current;
+						current = null;
+						ClientSideManagedConnection.this.notifyAll();
+						return result;
+					}
+					if (!map.containsKey(id)) {
+						throw new FramsticksException().msg("id is unknown").arg("id", id);
+					}
+
+					T result = map.get(id);
+					if (remove) {
+						map.remove(id);
+					}
+					return result;
+
+				} catch (FramsticksException e) {
+					throw new FramsticksException().msg("failed to match response to sent query").cause(e);
+				}
+			}
+		}
+	}
+
+	protected IdCollection<SentQuery<?>> sentQueries = new IdCollection<>();
+	protected IdCollection<NeedFile> needFiles = new IdCollection<>();
 
 	private int nextQueryId = 0;
@@ -269,6 +294,6 @@
 			throw new FramsticksException().msg("expected file line").arg("got", fileLine);
 		}
-		String eventObjectPath = Request.takeGroup(rest, matcher, 1).toString();
-		String eventCalleePath = Request.takeGroup(rest, matcher, 2).toString();
+		String eventObjectPath = Strings.takeGroup(rest, matcher, 1).toString();
+		String eventCalleePath = Strings.takeGroup(rest, matcher, 2).toString();
 		final File file = new File("", new ListSource(readFileContent()));
 		log.debug("firing event {}", eventObjectPath);
@@ -277,5 +302,5 @@
 			listener = registeredListeners.get(eventObjectPath);
 		}
-		if (listener  == null) {
+		if (listener == null) {
 			throw new FramsticksException().msg("failed to find registered event").arg("event path", eventObjectPath).arg("object", eventCalleePath);
 		}
@@ -283,6 +308,48 @@
 	}
 
+	protected void processNeedFile(Pair<Integer, CharSequence> rest) {
+		final Integer id = rest.first;
+		String suggestedName = null;
+		String description = null;
+		Pair<CharSequence, CharSequence> s = Request.takeString(rest.second);
+		if (s != null) {
+			suggestedName = s.first.toString();
+			Pair<CharSequence, CharSequence> d = Request.takeString(s.second);
+			if (d != null) {
+				description = d.first.toString();
+			}
+		}
+
+		final Future<File> future = new Future<File>() {
+
+			protected void send(final File result) {
+				log.info("sending file: " + result);
+				needFiles.clear(id);
+				sendFile(null, result, id, ClientSideManagedConnection.this);
+
+			}
+
+			@Override
+			protected void result(File result) {
+				send(result);
+			}
+
+			@Override
+			public void handle(FramsticksException exception) {
+				send(new File("", ListSource.createFrom("# invalid", "# " + exception.getMessage())));
+			}
+		};
+
+		NeedFile needFile = new NeedFile(suggestedName, description, future);
+
+		if (needFileAcceptor.acceptNeed(needFile)) {
+			return;
+		}
+
+		future.handle(new FramsticksException().msg("acceptor did not accepted need"));
+	}
+
 	protected void processFile(Pair<Integer, CharSequence> rest) {
-		final SentQuery<?> sentQuery = fetchQuery(rest.first, false);
+		final SentQuery<?> sentQuery = sentQueries.fetch(rest.first, false);
 
 		String currentFilePath = rest.second.toString();
@@ -292,5 +359,4 @@
 
 		sentQuery.files.add(new File(currentFilePath, new ListSource(readFileContent())));
-
 	}
 
@@ -318,9 +384,13 @@
 			if (keyword.equals("ok") || keyword.equals("error")) {
 
-				final SentQuery<?> sentQuery = fetchQuery(rest.first, true);
+				final SentQuery<?> sentQuery = sentQueries.fetch(rest.first, true);
 
 				log.debug("parsing response for request {}", sentQuery);
 
 				sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second.toString(), sentQuery.getFiles()));
+				return;
+			}
+			if (keyword.equals("needfile")) {
+				processNeedFile(rest);
 				return;
 			}
@@ -336,5 +406,5 @@
 		@Override
 		public void handle(FramsticksException exception) {
-			interrupt();
+			interruptJoinable();
 			// finish();
 		}
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 101)
@@ -1,4 +1,5 @@
 package com.framsticks.communication;
 
+import com.framsticks.params.Source;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -60,5 +61,4 @@
 		threads.add(senderThread);
 		threads.add(receiverThread);
-
 	}
 
@@ -242,6 +242,6 @@
 			protected void runAt() {
 				receiverThreadRoutine();
-				interrupt();
-				finish();
+				interruptJoinable();
+				finishJoinable();
 			}
 		});
@@ -251,5 +251,5 @@
 	protected void joinableInterrupt() {
 		Dispatching.drop(threads, this);
-		finish();
+		finishJoinable();
 	}
 
@@ -331,3 +331,30 @@
 
 
+	protected static String idToString(Integer id) {
+		return id != null ? " " + id.toString() : "";
+	}
+
+	protected final void putFile(File file, Integer outId) {
+		putLine("file" + idToString(outId)/* + " " + f.getPath()*/);
+		Source content = file.getContent();
+		String line;
+		while ((line = content.readLine()) != null) {
+			putLine(line);
+		}
+		putLine("eof");
+	}
+
+	public final void sendFile(final String header, final File file, final Integer id, ExceptionResultHandler handler) {
+		senderThread.dispatch(new RunAt<Connection>(handler) {
+			@Override
+			protected void runAt() {
+				if (header != null) {
+					putLine(header);
+				}
+				putFile(file, id);
+				flushOut();
+			}
+		});
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/communication/File.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/File.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/communication/File.java	(revision 101)
@@ -6,6 +6,7 @@
 import javax.annotation.Nonnull;
 
-import com.framsticks.params.SourceInterface;
+import com.framsticks.params.Source;
 // import com.framsticks.util.lang.Strings;
+import com.framsticks.util.lang.Strings;
 
 /**
@@ -14,7 +15,7 @@
 public final class File {
 	protected final String path;
-	protected final SourceInterface content;
+	protected final Source content;
 
-	public File(@Nonnull String path, @Nonnull SourceInterface content) {
+	public File(@Nonnull String path, @Nonnull Source content) {
 		// assert Strings.notEmpty(path);
 		this.path = path;
@@ -26,5 +27,5 @@
 	}
 
-	public SourceInterface getContent() {
+	public Source getContent() {
 		return content;
 	}
@@ -35,3 +36,14 @@
 		return result;
 	}
+
+	@Override
+	public String toString() {
+		StringBuilder b = new StringBuilder();
+		if (Strings.notEmpty(path)) {
+			b.append(path).append(": ");
+		}
+		b.append(content.toString());
+		return b.toString();
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/communication/Request.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Request.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/communication/Request.java	(revision 101)
@@ -7,4 +7,5 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 
 /**
@@ -78,8 +79,4 @@
 	}
 
-	public static CharSequence takeGroup(CharSequence input, Matcher matcher, int group) {
-		// return (matcher.start(group) == matcher.end(group)) ? null : input.subSequence(matcher.start(group), matcher.end(group));
-		return input.subSequence(matcher.start(group), matcher.end(group));
-	}
 
 	public static Pair<CharSequence, CharSequence> takeString(CharSequence line) {
@@ -89,8 +86,8 @@
 		}
 		assert ((matcher.start(1) == -1) != (matcher.start(2) == -1));
-		return new Pair<CharSequence, CharSequence>(takeGroup(line, matcher, (matcher.start(1) != -1 ? 1 : 2)), takeGroup(line, matcher, 3));
+		return new Pair<CharSequence, CharSequence>(Strings.takeGroup(line, matcher, (matcher.start(1) != -1 ? 1 : 2)), Strings.takeGroup(line, matcher, 3));
 	}
 
-	protected static final Pattern REQUEST_ID_BREAKER_PATTERN = Pattern.compile("^\\s*([0-9]+)\\s*(.*)$");
+	protected static final Pattern REQUEST_ID_BREAKER_PATTERN = Pattern.compile("^\\s*(-?[0-9]+)\\s*(.*)$");
 
 	protected final static Pair<Integer, CharSequence> takeRequestId(boolean withId, CharSequence line) {
@@ -100,5 +97,5 @@
 				return null;
 			}
-			return new Pair<Integer, CharSequence>(Integer.valueOf(takeGroup(line, matcher, 1).toString()), takeGroup(line, matcher, 2));
+			return new Pair<Integer, CharSequence>(Integer.valueOf(Strings.takeGroup(line, matcher, 1).toString()), Strings.takeGroup(line, matcher, 2));
 		}
 		return new Pair<Integer, CharSequence>(null, line);
Index: java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 101)
@@ -2,5 +2,4 @@
 
 import com.framsticks.communication.queries.*;
-import com.framsticks.params.SourceInterface;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Holder;
@@ -69,24 +68,5 @@
 	}
 
-	protected final void putFile(File file, String outId) {
-		putLine("file" + outId/* + " " + f.getPath()*/);
-		SourceInterface content = file.getContent();
-		String line;
-		while ((line = content.readLine()) != null) {
-			putLine(line);
-		}
-		putLine("eof");
-	}
 
-	public final void sendFile(final String header, final File file) {
-		senderThread.dispatch(new RunAt<Connection>(requestHandler) {
-			@Override
-			protected void runAt() {
-				putLine(header);
-				putFile(file, "");
-				flushOut();
-			}
-		});
-	}
 
 	protected final void respond(final Response response, final Integer id) {
@@ -94,12 +74,11 @@
 			@Override
 			protected void runAt() {
-				String outId = id != null ? " " + id : "";
 				if (response.getFiles() != null) {
 					for (File f : response.getFiles()) {
-						putFile(f, outId);
+						putFile(f, id);
 					}
 				}
 				StringBuilder statusLine = new StringBuilder();
-				statusLine.append(response.getOk() ? "ok" : "error").append(outId);
+				statusLine.append(response.getOk() ? "ok" : "error").append(idToString(id));
 				if (Strings.notEmpty(response.getComment())) {
 					Request.quoteValue(statusLine.append(" "), response.getComment());
Index: java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java	(revision 101)
@@ -17,5 +17,4 @@
 
 	public CallRequest addArguments(String arguments) {
-		// this.arguments = arguments;
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/communication/queries/NeedFile.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/NeedFile.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/communication/queries/NeedFile.java	(revision 101)
@@ -0,0 +1,50 @@
+package com.framsticks.communication.queries;
+
+import com.framsticks.communication.File;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.lang.Strings;
+
+public class NeedFile {
+
+	protected final String suggestedName;
+	protected final String description;
+	protected final Future<File> future;
+
+	/**
+	 * @param suggestedName
+	 * @param description
+	 * @param future
+	 */
+	public NeedFile(String suggestedName, String description, Future<File> future) {
+		this.suggestedName = suggestedName;
+		this.description = description;
+		this.future = future;
+	}
+
+	/**
+	 * @return the suggestedName
+	 */
+	public String getSuggestedName() {
+		return suggestedName;
+	}
+
+	/**
+	 * @return the description
+	 */
+	public String getDescription() {
+		return description;
+	}
+
+	/**
+	 * @return the future
+	 */
+	public Future<File> getFuture() {
+		return future;
+	}
+
+	@Override
+	public String toString() {
+		return Strings.toStringEmptyProof(suggestedName, "?") + " " + Strings.toStringEmptyProof(description, "?");
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/communication/queries/NeedFileAcceptor.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/NeedFileAcceptor.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/communication/queries/NeedFileAcceptor.java	(revision 101)
@@ -0,0 +1,8 @@
+package com.framsticks.communication.queries;
+
+
+public interface NeedFileAcceptor {
+
+	public boolean acceptNeed(NeedFile needFile);
+
+}
Index: java/main/src/main/java/com/framsticks/core/AbstractTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 101)
@@ -1,5 +1,8 @@
 package com.framsticks.core;
 
+import java.util.Comparator;
+import java.util.Iterator;
 import java.util.Map;
+import java.util.PriorityQueue;
 
 import javax.annotation.Nonnull;
@@ -9,7 +12,10 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.communication.queries.NeedFile;
+import com.framsticks.communication.queries.NeedFileAcceptor;
 import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.ParamsPackage;
 import com.framsticks.params.Registry;
@@ -20,9 +26,9 @@
 import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.BufferedDispatcher;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Joinable;
-import com.framsticks.util.dispatching.JoinableDispatcher;
 import com.framsticks.util.dispatching.JoinableParent;
 import com.framsticks.util.dispatching.JoinableState;
@@ -30,5 +36,5 @@
 import com.framsticks.util.dispatching.Thread;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
-import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Pair;
 
 /**
@@ -36,5 +42,5 @@
  */
 @FramsClassAnnotation
-public abstract class AbstractTree extends AbstractJoinable implements Dispatcher<Tree>, Tree, JoinableParent {
+public abstract class AbstractTree extends AbstractJoinable implements Dispatcher<Tree>, Tree, JoinableParent, NeedFileAcceptor {
 
 	private static final Logger log = LogManager.getLogger(AbstractTree.class);
@@ -43,5 +49,19 @@
 	private ExceptionResultHandler handler = ThrowExceptionHandler.getInstance();
 
-	private JoinableDispatcher<Tree> dispatcher;
+	protected final BufferedDispatcher<Tree> bufferedDispatcher = new BufferedDispatcher<>();
+
+	protected final PriorityQueue<Pair<Integer, NeedFileAcceptor>> needFileAcceptors = new PriorityQueue<>(32, new Comparator<Pair<Integer, NeedFileAcceptor>>() {
+
+		@Override
+		public int compare(Pair<Integer, NeedFileAcceptor> arg0, Pair<Integer, NeedFileAcceptor> arg1) {
+			if (arg0.first < arg1.first) {
+				return -1;
+			}
+			if (arg0.first > arg1.first) {
+				return 1;
+			}
+			return 0;
+		}
+	});
 
 	@Override
@@ -152,6 +172,6 @@
 	 */
 	@Override
-	public JoinableDispatcher<Tree> getDispatcher() {
-		return dispatcher;
+	public Dispatcher<Tree> getDispatcher() {
+		return bufferedDispatcher.getTargetDispatcher();
 	}
 
@@ -160,9 +180,9 @@
 	 */
 	@Override
-	public void setDispatcher(JoinableDispatcher<Tree> dispatcher) {
-		if (this.dispatcher != null) {
-			throw new FramsticksException().msg("dispatcher is already set").arg("tree", this).arg("dispatcher", dispatcher);
-		}
-		this.dispatcher = dispatcher;
+	public void setDispatcher(Dispatcher<Tree> dispatcher) {
+		if (bufferedDispatcher.getTargetDispatcher() != null) {
+			throw new FramsticksException().msg("dispatcher is already set").arg("tree", this).arg("dispatcher", bufferedDispatcher.getTargetDispatcher());
+		}
+		bufferedDispatcher.setTargetDispatcher(dispatcher);
 	}
 
@@ -170,5 +190,5 @@
 	 * @return the name
 	 */
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public String getName() {
 		return name;
@@ -193,13 +213,13 @@
 	@Override
 	protected void joinableStart() {
-		if (dispatcher == null) {
-			dispatcher = new Thread<Tree>();
-		}
-		Dispatching.use(dispatcher, this);
+		if (bufferedDispatcher.getTargetDispatcher() == null) {
+			bufferedDispatcher.setTargetDispatcher(new Thread<Tree>());
+		}
+		Dispatching.use(bufferedDispatcher.getTargetDispatcher(), this);
 	}
 
 	@Override
 	protected void joinableInterrupt() {
-		Dispatching.drop(dispatcher, this);
+		Dispatching.drop(bufferedDispatcher.getTargetDispatcher(), this);
 	}
 
@@ -211,10 +231,10 @@
 	@Override
 	protected void joinableJoin() throws InterruptedException {
-		Dispatching.join(dispatcher);
+		Dispatching.join(bufferedDispatcher.getTargetDispatcher());
 	}
 
 	@Override
 	public void childChangedState(Joinable joinable, JoinableState state) {
-		if (joinable == dispatcher) {
+		if (joinable == bufferedDispatcher.getTargetDispatcher()) {
 			proceedToState(state);
 		}
@@ -223,16 +243,10 @@
 	@Override
 	public boolean isActive() {
-		if (dispatcher == null) {
-			throw new FramsticksException().msg("no dispatcher is set for tree yet").arg("tree", this);
-		}
-		return dispatcher.isActive();
+		return bufferedDispatcher.isActive();
 	}
 
 	@Override
 	public void dispatch(RunAt<? extends Tree> runnable) {
-		if (dispatcher == null) {
-			throw new FramsticksException().msg("no dispatcher is set for tree yet").arg("tree", this);
-		}
-		dispatcher.dispatch(runnable);
+		bufferedDispatcher.dispatch(runnable);
 	}
 
@@ -242,5 +256,5 @@
 
 	@Override
-	public void putSideNote(Object object, Object key, Object value) {
+	public <T> void putSideNote(Object object, SideNoteKey<T> key, T value) {
 		assert isActive();
 		Misc.throwIfNull(object);
@@ -253,10 +267,11 @@
 		}
 		@SuppressWarnings("unchecked")
-		Map<Object, Object> sideNotesMap = (Map<Object, Object>) sideNote;
+		Map<SideNoteKey<?>, Object> sideNotesMap = (Map<SideNoteKey<?>, Object>) sideNote;
 		sideNotesMap.put(key, value);
 	}
 
-	@Override
-	public <T> T getSideNote(Object object, Object key, Class<T> valueType) {
+	@SuppressWarnings("unchecked")
+	@Override
+	public <T> T getSideNote(Object object, SideNoteKey<T> key) {
 		assert isActive();
 		Misc.throwIfNull(object);
@@ -266,9 +281,14 @@
 			return null;
 		}
-		return Casting.nullOrThrowCast(valueType, ((Map<?, ?>) sideNote).get(key));
-	}
-
-	@Override
-	public boolean removeSideNote(Object object, Object key) {
+		Object value = ((Map<SideNoteKey<?>, Object>) sideNote).get(key);
+		if (value == null) {
+			return null;
+		}
+		return (T) value;
+	}
+
+	@Override
+	public boolean removeSideNote(Object object, SideNoteKey<?> key) {
+		assert isActive();
 		Object sideNote = sideNotes.get(object);
 		if (sideNote == null) {
@@ -276,5 +296,5 @@
 		}
 		@SuppressWarnings("unchecked")
-		Map<Object, Object> sideNotesMap = (Map<Object, Object>) sideNote;
+		Map<SideNoteKey<?>, Object> sideNotesMap = (Map<SideNoteKey<?>, Object>) sideNote;
 		boolean result = (sideNotesMap.remove(key) != null);
 		if (sideNotesMap.isEmpty()) {
@@ -284,4 +304,39 @@
 	}
 
+	@Override
+	public void addNeedFileAcceptor(int priority, NeedFileAcceptor acceptor) {
+		assert isActive();
+		needFileAcceptors.add(Pair.make(priority, acceptor));
+	}
+
+	@Override
+	public void removeNeedFileAcceptor(NeedFileAcceptor acceptor) {
+		assert isActive();
+		Iterator<Pair<Integer, NeedFileAcceptor>> i = needFileAcceptors.iterator();
+		while (i.hasNext()) {
+			if (i.next().second == acceptor) {
+				i.remove();
+				break;
+			}
+		}
+	}
+
+	@Override
+	public boolean acceptNeed(final NeedFile needFile) {
+		Dispatching.dispatchIfNotActive(this, new RunAt<AbstractTree>(needFile.getFuture()) {
+
+			@Override
+			protected void runAt() {
+				for (Pair<Integer, NeedFileAcceptor> acceptor : needFileAcceptors) {
+					if (acceptor.second.acceptNeed(needFile)) {
+						return;
+					}
+				}
+				throw new FramsticksException().msg("failed to find need file acceptor in tree").arg("tree", AbstractTree.this);
+			}
+		});
+		return true;
+	}
+
 }
 
Index: java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 101)
@@ -29,5 +29,5 @@
 	public static void main(final String[] args) {
 
-		String config = "/configs/framsticks.xml";
+		String config = "/framsticks.xml";
 		if (args.length != 0) {
 			config = args[0];
Index: java/main/src/main/java/com/framsticks/core/LocalTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 101)
@@ -15,5 +15,8 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableState;
 
 import static com.framsticks.core.TreeOperations.*;
@@ -23,5 +26,5 @@
 	private static final Logger log = LogManager.getLogger(LocalTree.class);
 
-	protected Object rootObject;
+	protected Joinable joinableRootObject;
 
 	/**
@@ -42,4 +45,8 @@
 		assignRootParam(access.buildParam(new ParamBuilder()).id(getName()).finish(CompositeParam.class));
 		assignRootObject(object);
+
+		if (object instanceof Joinable) {
+			joinableRootObject = (Joinable) object;
+		}
 	}
 
@@ -69,7 +76,7 @@
 	// @Override
 	// public void get(Path path, ValueParam param, Future<Object> future) {
-	// 	assert isActive();
-	// 	path = resolveTopSync(path);
-	// 	future.pass(bindAccess(path).get(param, Object.class));
+	//	assert isActive();
+	//	path = resolveTopSync(path);
+	//	future.pass(bindAccess(path).get(param, Object.class));
 	// }
 
@@ -137,3 +144,40 @@
 		}
 	}
+
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		if (joinableRootObject != null) {
+			Dispatching.use(joinableRootObject, this);
+		}
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		if (joinableRootObject != null) {
+			Dispatching.drop(joinableRootObject, this);
+		}
+		super.joinableInterrupt();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		super.joinableFinish();
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		if (joinableRootObject != null) {
+			Dispatching.join(joinableRootObject);
+		}
+		super.joinableJoin();
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		super.childChangedState(joinable, state);
+		if (joinable == joinableRootObject) {
+			proceedToState(state);
+		}
+	}
 }
Index: java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Path.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/core/Path.java	(revision 101)
@@ -31,4 +31,6 @@
 	final LinkedList<Node> nodes;
 
+	public static final SideNoteKey<CompositeParam> OBJECT_PARAM_KEY = SideNoteKey.make(CompositeParam.class);
+
 	protected static Object getKnownChild(Tree tree, Access access, CompositeParam param, ExceptionResultHandler handler) {
 		Object child = access.get(param, Object.class);
@@ -38,5 +40,5 @@
 		try {
 			tree.prepareAccess(param);
-			tree.putSideNote(child, CompositeParam.class, param);
+			tree.putSideNote(child, OBJECT_PARAM_KEY, param);
 			return child;
 		} catch (FramsticksException e) {
@@ -164,5 +166,5 @@
 				b.append("/").append(e);
 				access.select(current.getObject());
-				tree.putSideNote(current.getObject(), CompositeParam.class, current.getParam());
+				tree.putSideNote(current.getObject(), OBJECT_PARAM_KEY, current.getParam());
 				current = new Node(current.getTree(), c, getKnownChild(tree, access, c, handler));
 				nodes.add(current);
Index: java/main/src/main/java/com/framsticks/core/SideNoteKey.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/SideNoteKey.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/SideNoteKey.java	(revision 101)
@@ -0,0 +1,28 @@
+package com.framsticks.core;
+
+import com.framsticks.util.FramsticksException;
+
+public class SideNoteKey<T> {
+
+	protected final Class<T> type;
+
+	/**
+	 * @param type
+	 */
+	public SideNoteKey(Class<T> type) {
+		this.type = type;
+	}
+
+	public static <T2> SideNoteKey<T2> make(Class<T2> type) {
+		return new SideNoteKey<T2>(type);
+	}
+
+	public T newValue() {
+		try {
+			return type.newInstance();
+		} catch (InstantiationException | IllegalAccessException e) {
+			throw new FramsticksException().msg("failed to create side note value").arg("type", type).cause(e);
+		}
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/core/Tree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Tree.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/core/Tree.java	(revision 101)
@@ -3,4 +3,5 @@
 import javax.annotation.Nonnull;
 
+import com.framsticks.communication.queries.NeedFileAcceptor;
 import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
@@ -15,5 +16,4 @@
 import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.Joinable;
-import com.framsticks.util.dispatching.JoinableDispatcher;
 
 public interface Tree extends Dispatcher<Tree>, Joinable, ExceptionResultHandler {
@@ -54,7 +54,7 @@
 	public ExceptionResultHandler getExceptionHandler();
 
-	public void setDispatcher(JoinableDispatcher<Tree> dispatcher);
+	public void setDispatcher(Dispatcher<Tree> dispatcher);
 
-	public JoinableDispatcher<Tree> getDispatcher();
+	public Dispatcher<Tree> getDispatcher();
 
 	public <A> void addListener(Path path, EventParam param, EventListener<A> listener, Class<A> argumentType, Future<Void> future);
@@ -64,9 +64,13 @@
 	public Registry getRegistry();
 
-	public void putSideNote(Object object, Object key, Object value);
+	public <T> void putSideNote(Object object, SideNoteKey<T> key, T value);
 
-	public boolean removeSideNote(Object object, Object key);
+	public boolean removeSideNote(Object object, SideNoteKey<?> key);
 
-	public <T> T getSideNote(Object object, Object key, Class<T> valueType);
+	public <T> T getSideNote(Object object, SideNoteKey<T> key);
+
+	public void addNeedFileAcceptor(int priority, NeedFileAcceptor acceptor);
+
+	public void removeNeedFileAcceptor(NeedFileAcceptor acceptor);
 
 }
